<?php
/*
 * $RCSfile: Callbacks.inc,v $Revision: 1.14 $
 *
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2005 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
/**
 * @version 0.5.0f
 * @package Map
 * @author Eric H Daniel <ehdaniel@gmail.com>
 *
 * This is some of the ugliest code I've ever written. Please do not
 * judge me by it. :)
 *
 * based on some code form CustomField by Alan Harder <alan.harder@sun.com>
 */
class mapCallbacks {
    /**
     */
    function callback($params, &$smarty, $callback, $userId=null) {
	global $gallery;
        list ($ret, $module) = GalleryCoreApi::loadPlugin('module', 'map');
        if ($ret) {
          return $ret->wrap(__FILE__, __LINE__);
        }
	GalleryCoreApi::requireOnce('modules/map/classes/mapHelper.class');

	switch ($callback) {
	case 'Loadmaps':
	    list ($ret, $item) = GalleryCoreApi::loadEntitiesById($params['itemId']);
            if ($ret) {
                 return $ret->wrap(__FILE__, __LINE__);
            }
	    list ($ret, $fields) = mapHelper::fetchFieldValues(array($item), 'detail');
            if ($ret) {
                 return $ret->wrap(__FILE__, __LINE__);
            }
        case 'LoadFilters':
            if (GalleryUtilities::getRequestVariables('view') == "map.ShowMap"){
            list ($ret, $filters) = GalleryCoreApi::getPluginParameter('module','map','Filters');
            if ($ret) {
                 return $ret->wrap(__FILE__, __LINE__);
            }

            list ($ret, $routes) = GalleryCoreApi::getPluginParameter('module','map','Routes');
            if ($ret) {
                 return $ret->wrap(__FILE__, __LINE__);
            }

	    $routefilters=array();
            if (!empty($routes)) { //we have some routes, check if there is a need to create a filter for them
	      $routearray = explode ("|",$routes);
	      $i=0;
	      $routeword = $module->translate("Route:");
	      foreach ($routearray as $route) {
                $routeinfos = explode ("`",$route);
                if ($routeinfos[6] == "Yes"){  //yep, need a filter for that route :-)
                  $routefilters[$i]['name'] = $routeword." ".$routeinfos[1];
                  $routefilters[$i]['params'] = array (
                                         "view" =>"map.ShowMap",
                                         "Group" => "",
                                         "filter" => "Route: ".$routeinfos[1]);
                  $i++;
                }
              }
            }

            list ($ret, $showalbumfilters) = GalleryCoreApi::getPluginParameter('module','map','ShowAlbumFilters');
            if ($ret) {
                 return $ret->wrap(__FILE__, __LINE__);
            }

	    if (!empty($showalbumfilters) and $showalbumfilters == "1"){
              list ($ret, $albumlist) = GalleryCoreApi::getPluginParameter('module','map','albumlist');
              if ($ret) {
                   return $ret->wrap(__FILE__, __LINE__);
              }

    	      $albumfilters=array();
              if (!empty($albumlist))
              {
                $i=0;
                $listofalbums = explode ("`",$albumlist);
                $albumword = $module->translate("Album:");
                foreach ($listofalbums as $album)
                {
                  $albumfilters[$i]['name'] = $albumword." ".$album;
                  $albumfilters[$i]['params'] = array (
                                             "view" => "map.ShowMap",
                                             "Group" => "",
                                             "album" => $album);
                  $i++;
                }
              }
            }

            $filteroptions=array();
            if ((!empty($filters) and $filters != "") or (!empty($albumfilters)) or (!empty($routefilters)))
            {
              $filteroptions[0]['name'] = $module->translate("Default");
              $filteroptions[0]['params'] = array (
                               "view" => "map.ShowMap",
                               "Group" => "");
            }

            if (!empty($filters) and $filters != "") {
              $separatedfilters = explode("|",$filters);
              $i=1;
              foreach ($separatedfilters as $alloptions) {
                $options = explode("`",$alloptions);
                $filteroptions[$i]['name'] = $options[1];
                $filteroptions[$i]['params'] = array (
                               "view" => "map.ShowMap",
                               "Group" => "",
                               "filter" => $options[1]);
                $i++;
              }
            }
            elseif (empty($routefilters) and empty($albumfilters)) {
            $filteroptions[0]['name'] = $module->translate("&laquo; No Filters &raquo;");
            $filteroptions[0]['params'] = "";
            $filteroptions[1]['name'] = $module->translate("Define...");
            $filteroptions[1]['params'] = array (
                               "view" => "core.SiteAdmin",
                               "subView" => "map.MapFilterAdmin");
            }

	    if (!empty($routefilters)){
              foreach ($routefilters as $routefilter) { //add the Route filters at the end of the filter list
                $filteroptions[] = $routefilter;
              }
            }          
	    if (!empty($albumfilters)){
              foreach ($albumfilters as $albumfilter) { //add the Album filters at the end of the filter list
                $filteroptions[] = $albumfilter;
              }
            }
            $filter = GalleryUtilities::getRequestVariables('filter');
	    $album = GalleryUtilities::getRequestVariables('album');
	    $filterOn = ($filter == "" or empty($filter)) ? $albumword." ".$album:$filter;
            $block =& $smarty->_tpl_vars['block'];
            $block['map']['LoadFilters']['filters'] = $filteroptions;
            $block['map']['LoadFilters']['filterOn'] = $filterOn;
            }

	    return null;
	}

	return GalleryCoreApi::error(ERROR_BAD_PARAMETER, __FILE__, __LINE__);
    }
}
?>
