<?php
/*
 * $Revision: 1.63 $
 *
 * $RCSfile: MapSiteAdmin.inc
 *
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2005 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street - Fifth Floor, Boston, MA  02110-1301, USA.
 */
/**
 * @version 0.5.1a
 * @package Map
 * @author Steven N. Severinghaus <sns@severinghaus.org>
 *
 * This is some of the ugliest code I've ever written. Please do not
 * judge me by it. :)
 */

GalleryCoreApi::requireOnce('modules/map/classes/mapHelper.class');
GalleryCoreApi::requireOnce('modules/map/classes/GoogleMapUtilities.class');

/**
 * @package map
 * @subpackage UserInterface
 */
class MapSiteAdminController extends GalleryController {
    /**
     * @see GalleryController::handleRequest
     */
    function handleRequest($form) {

        include(dirname(__FILE__).'/includes/MapAdminControllerInit.inc');

        //Cancel hit, return to the default Admin Page
        if (isset($form['action']['cancel'])) {

            $results['status'] = $status;
            $results['error'] = array ();
            $results['redirect']['view'] = 'core.SiteAdmin';
            $results['redirect']['subView'] = 'map.MapSiteAdmin';
        }

        //Save general settings
        if (isset($form['action']['save'])) {
            // Check for errors
            if (!is_numeric($form['mapWidth']) || intval($form['mapWidth'])!=$form['mapWidth']) { // check for errors
                $error[] = 'form[error][mapWidth]';
            } elseif (!is_numeric($form['mapHeight']) || intval($form['mapHeight'])!=$form['mapHeight']) {
                $error[] = 'form[error][mapHeight]';
            } elseif (!isset($form['AutoCenterZoom']) && (empty($form['centerLongLat']) ||!preg_match('/^([-+]?(([0-9]{1,3}(\.[0-9]{0,16})?)|(\.[0-9]{1,16}))(\040)*,(\040)*[-+]?(([0-9]{1,3}(\.[0-9]{0,16})?)|(\.[0-9]{1,16})))?$/', $form['centerLongLat']))) {
                  $error[] = 'form[error][centerLongLat]';
            } elseif (!isset($form['AutoCenterZoom']) && (!is_numeric($form['zoomLevel']) || intval($form['zoomLevel'])!=$form['zoomLevel'] || $form['zoomLevel'] < 0 || $form['zoomLevel'] > 19)) {
                  $error[] = 'form[error][zoomLevel]';
            } elseif (!empty($form['GVMCenter']) && !preg_match('/^([-+]?(([0-9]{1,3}(\.[0-9]{0,16})?)|(\.[0-9]{1,16}))(\040)*,(\040)*[-+]?(([0-9]{1,3}(\.[0-9]{0,16})?)|(\.[0-9]{1,16})))?$/', $form['GVMCenter'])) {
              $error[] = 'form[error][GVMCenter]';
            } elseif (!empty($form['GVMZoom']) && (!is_numeric($form['GVMZoom']) || intval($form['GVMZoom'])!=$form['GVMZoom'] || $form['GVMZoom'] < 0 || $form['GVMZoom'] > 19)) {
              $error[] = 'form[error][GVMZoom]';
            }else{

                if(!array_key_exists('showScale', $form))            $form['showScale']=false;
                if(!array_key_exists('centerLongLat', $form))        $form['centerLongLat']='0,0';
                if(!array_key_exists('zoomLevel', $form))            $form['zoomLevel']='0';

                //Cleanup coordinates of any spaces
                if ($form['centerLongLat'] != "") $form['centerLongLat'] = str_replace(" ","",trim($form['centerLongLat']));

                // Save parameters if there have been no errors
                foreach (array('GVMZoom','GVMCenter','mapWidth','linktype','mapHeight','centerLongLat','zoomLevel','mapType','MapWidthFormat','MapHeightFormat') as $setting) {
                    GalleryCoreApi::setPluginParameter('module', 'map', $setting, $form[$setting]);
                }

                foreach (array('showScale', 'AutoCenterZoom', 'ShowExportGELink','GxMagnifierFeature',
                               'ThemeFeature','MarkerFeature','LegendFeature','FilterFeature','GroupFeature','RouteFeature') as $setting) {
                    GalleryCoreApi::setPluginParameter('module', 'map', $setting,
                        (isset($form[$setting]) && $form[$setting]) ? 1 : 0);
                }

                $status['saved'] = 1;
            }

            // Figure out the method we will use
            $method = empty($error) ? 'redirect' : 'delegate';
            $results['status'] = $status;
            $results['error'] = $error;
            $results[$method]['view'] = 'core.SiteAdmin';
            $results[$method]['subView'] = 'map.MapSiteAdmin';
            }

        if (isset($form['action']['editkey'])) {

            $id=$form['MapKeys'];

            $tmp = GalleryCoreApi::getPluginParameter('module', 'map', "MapKeys");
            $AllMapKeys = explode("|",$tmp[1]);

            $newkeys ="";
            foreach ($AllMapKeys as $key)
            {
              $temp = explode("`",$key);
              if ($temp[0] <> $id)
              {
                if ($newkeys=="") $newkeys = $key;
                else $newkeys = $newkeys."|".$key;
              } else {
                $editkey=$key;
              }
            }

            GalleryCoreApi::setPluginParameter('module', 'map', "MapKeys", $newkeys);
            GalleryCoreApi::setPluginParameter('module', 'map', "EditKey",$editkey);

            $results['status'] = '';
            $results['error'] = '';
            $results['redirect']['view'] = 'core.SiteAdmin';
            $results['redirect']['subView'] = 'map.MapSiteAdmin';
            $results['redirect']['mode'] = 'mapkey';
        }

        if (isset($form['action']['addkey'])) {

            GalleryCoreApi::setPluginParameter('module', 'map', "EditKey","");

            $results['status'] = '';
            $results['error'] = '';
            $results['redirect']['view'] = 'core.SiteAdmin';
            $results['redirect']['subView'] = 'map.MapSiteAdmin';
            $results['redirect']['mode'] = 'mapkey';
        }

        if (isset($form['action']['delkey'])) {

            $id=$form['MapKeys'];

            $tmp = GalleryCoreApi::getPluginParameter('module', 'map', "MapKeys");
            $currentprofiles = explode("|",$tmp[1]);

            $newprofiles ="";

            foreach ($currentprofiles as $profile)
            {
              $temp = explode("`",$profile);
              if ($temp[0] <> $id)
              {
                if ($newprofiles=="") $newprofiles = $profile;
                else $newprofiles = $newprofiles."|".$profile;
              }
            }

            GalleryCoreApi::setPluginParameter('module', 'map', "MapKeys", $newprofiles);

            if ($id !=0) $status['profiledeleted']=1;

            $results['status'] = $status;
            $results['error'] = '';
            $results['redirect']['view'] = 'core.SiteAdmin';
            $results['redirect']['subView'] = 'map.MapSiteAdmin';
            $results['redirect']['mode'] = 'General';
        }

        if (isset($form['action']['savekey'])) {

            //error checking
            if ($form['KeyProfileName'] == "") $form['error']['profilename']=1;
            elseif ($form['KeySvrName'] == "") $form['error']['profilesvr']=1;
            elseif ($form['keyMapKey'] == "") $form['error']['profilekey']=1;
            else {
            if ($form['KeyPortName'] == "") $form['KeyPortName'] ="80";
            $oldprofiles = GalleryCoreApi::getPluginParameter('module', 'map', "MapKeys");

            if ($oldprofiles[1] <> "")
            {
              $temp = explode("|",$oldprofiles[1]);
              $maxprofile = explode("`",max($temp));
              $num = $maxprofile[0]+1;

              $mapkey = $oldprofiles[1]."|".$num."`".$form['KeyProfileName']."`".$form['KeySvrName']."`".$form['KeyPortName']."`".$form['keyMapKey'];
            }
            else
            {
              $mapkey = "1`".$form['KeyProfileName']."`".$form['KeySvrName']."`".$form['KeyPortName']."`".$form['keyMapKey'];
            }

            GalleryCoreApi::setPluginParameter('module', 'map', "MapKeys", $mapkey);
            GalleryCoreApi::setPluginParameter('module', 'map', "EditKey","");
            }

            if (empty($error)) {
              $status['profilesaved']=1;

              list ($ret, $module) = GalleryCoreApi::loadPlugin('module', 'map');
              if ($ret) {
  	       return array($ret->wrap(__FILE__, __LINE__), null);
              }
              list ($ret, $isActive) = $module->isActive();
              if ($ret) {
                return array($ret->wrap(__FILE__, __LINE__), null);
              }
              $results['redirect']['view'] = 'core.SiteAdmin';
              if ($isActive) {
                $results['status'] = $status;
                $results['error'] = $error;
                $results['redirect']['subView'] = 'map.MapSiteAdmin';
                $results['redirect']['mode'] = 'General';
              } else {
                $status['configured'] = 'map';
                $results['status'] = $status;
                $results['error'] = $error;
                $results['redirect']['subView'] = 'core.AdminModules';
              }
            } else {
            $results['status'] = $status;
            $results['error'] = $error;
            $results['delegate']['view'] = 'core.SiteAdmin';
            $results['delegate']['subView'] = 'map.MapSiteAdmin';
            $results['delegate']['mode'] = 'addkey';
            }
        }

        if (isset($form['action']['getviamap'])) {

          $results['status'] = "";
          $results['error'] = array();
          $results['redirect']['view'] = 'map.ShowMap';
          $results['redirect']['Mode'] = 'Pick';
          $results['redirect']['plugin'] = 'AdminCenter';
        }

        if (isset($form['action']['getviamap2'])) {

          $results['status'] = "";
          $results['error'] = array();
          $results['redirect']['view'] = 'map.ShowMap';
          $results['redirect']['Mode'] = 'Pick';
          $results['redirect']['plugin'] = 'GVMDefault';
        }

        if (isset($form['action']['getEXIF'])) {

          $templateAdapter =& $gallery->getTemplateAdapter();
          $templateAdapter->registerTrailerCallback(
               array($this, 'getallexifparam'), array($form));
      
          $results['delegate']['view'] = 'core.ProgressBar';

          if (empty($results['delegate'])) {
	    $results['delegate']['view'] = 'core.SiteAdmin';
	    $results['delegate']['subView'] = 'map.MapSiteAdmin';
	  }
          $status['exifsaved'] = $total;
          $results['status'] = $status;
	  $results['error'] = $error;
        }

        return array (null, $results);
    }
    function getallexifparam($form){
          global $gallery;
          $templateAdapter =& $gallery->getTemplateAdapter();
          list ($ret, $module) = GalleryCoreApi::loadPlugin('module', 'map');
   	  if ($ret) {
            return $ret->wrap(__FILE__, __LINE__);
          }

          $query = '
       	  SELECT
       	        [PhotoItem::id]
          FROM
       	        [PhotoItem]
       	  ORDER BY [PhotoItem::id]
       	  ';
       	  list ($ret, $result) = $gallery->search($query);
          if ($ret) {
               return $ret->wrap(__FILE__, __LINE__);
          }
      	  $ids = array();
          while ($res = $result->nextResult()) {
            $ids[] = $res[0];
          }
          $totalitems = count($ids);

          list ($ret, $exif) = GalleryCoreApi::newFactoryInstance('ExifInterface_1_0');
          if ($ret) {
               return $ret->wrap(__FILE__, __LINE__);
          }
          $insertEXIFcoordinates = $module->translate('Inserting GPS coordinate from EXIF header');
          if (isset($exif)) {
          $current = 1;
          foreach($ids as $i){
            list ($ret, $exifData) = $exif->getMetaData($i);
            if ($ret) {
                 return $ret->wrap(__FILE__, __LINE__);
            }
            if (!empty($exifData) and array_key_exists('GPS/Latitude',$exifData[$i])){
              list($ret, $item)=GalleryCoreApi::loadEntitiesById($i);
              $lat = explode(" ",str_replace(",",".",$exifData[$id]['GPS/Latitude']['value']));
              $lon = explode(" ",str_replace(",",".",$exifData[$id]['GPS/Longitude']['value']));
              if ((count($lat)<3) || (count($lon)<3)) $form['invalidgpsformat']=1;
              $Glatitude = $lat[0] + (isset($lat[1]) ? $lat[1]/60 : 0) + (isset($lat[2]) ? $lat[2]/3600 : 0);
              $Glatitude = ($exifData[$i]['GPS/LatitudeReference']['value']=="N") ? $Glatitude:-$Glatitude;
              $Glatitude = str_replace(",",".",$Glatitude);
              $Glongitude = $lon[0] + (isset($lon[1]) ? $lon[1]/60 : 0) + (isset($lon[2]) ? $lon[2]/3600 : 0);
              $Glongitude = ($exifData[$i]['GPS/LongitudeReference']['value']=="E") ? $Glongitude:-$Glongitude;
              $Glongitude = str_replace(",",".",$Glongitude);
              $coordinates = $Glatitude.",".$Glongitude;
              $items = array();                              
              $items[] = $item;
              list($ret,$fields) = mapHelper::fetchFieldValues($items);
              $fields[$i]['GPS'] = $coordinates;
              $ret = mapHelper::saveFieldValues($item, $fields[$i]);
              if ($ret) {
                   return $ret->wrap(__FILE__, __LINE__);
              }
            }
	    $ret = $templateAdapter->updateProgressBar(
            $insertEXIFcoordinates,
            $module->translate(array('text' => 'Item %d of %d',
                                 'arg1' => $current,
                                 'arg2' => $totalitems)),
                                 $current / $totalitems);
	    if ($ret) {
		return $ret->wrap(__FILE__, __LINE__);
	    }
	    $current++;
          }

          }
          $redirect['view'] = 'core.SiteAdmin';
          $redirect['subView'] = 'map.MapSiteAdmin';

          $urlGenerator =& $gallery->getUrlGenerator();
          $templateAdapter->completeProgressBar($urlGenerator->generateUrl($redirect));

          return null;
    }
}

/**
 * @package map
 * @subpackage UserInterface
 */
class mapSiteAdminView extends GalleryView {
    /**
     * @see GalleryView::loadTemplate
     */
    function loadTemplate(&$template, &$form) {

        include(dirname(__FILE__).'/includes/MapAdminViewInit.inc');
        $form['formName'] = 'mapSiteAdmin';
        $template->head('modules/map/includes/GoogleMap.css');
        $template->javascript('modules/map/GoogleMap.js');

        // Set default values for undefined plugin parameters
        if(!array_key_exists('googleMapKey', $form))         $form['googleMapKey']="";
        if(!array_key_exists('mapWidth', $form))             $form['mapWidth']=600;
        if(!array_key_exists('mapHeight', $form))            $form['mapHeight']=400;
        if(!array_key_exists('centerLongLat', $form))        $form['centerLongLat']="0,0";
        if(!array_key_exists('zoomLevel', $form))            $form['zoomLevel']=17;
        if(!array_key_exists('mapType', $form))              $form['mapType']="G_SATELLITE_TYPE";
        if(!array_key_exists('showScale', $form))            $form['showScale']=false;
        if(!array_key_exists('AutoCenterZoom', $form))       $form['AutoCenterZoom']=false;
        if(!array_key_exists('ShowExportGELink', $form))     $form['ShowExportGELink']=true;
        if(!array_key_exists('MapWidthFormat', $form))       $form['MapWidthFormat']=1; //pixels by default
        if(!array_key_exists('MapHeightFormat', $form))      $form['MapHeightFormat']=1; //pixels by default
        if(!array_key_exists('GxMagnifierFeature', $form))   $form['GxMagnifierFeature']=0; //Disabled by default
        if(!array_key_exists('ThemeFeature', $form))         $form['ThemeFeature']=0; //Disabled by default
        if(!array_key_exists('MarkerFeature', $form))        $form['MarkerFeature']=0; //Disabled by default
        if(!array_key_exists('LegendFeature', $form))        $form['LegendFeature']=0; //Disabled by default
        if(!array_key_exists('FilterFeature', $form))        $form['FilterFeature']=0; //Disabled by default
        if(!array_key_exists('GroupFeature', $form))         $form['GroupFeature']=0; //Disabled by default
        if(!array_key_exists('RouteFeature', $form))         $form['RouteFeature']=0; //Disabled by default
        if(!array_key_exists('linktype', $form))             $form['linktype']=0; //Default link

        include(dirname(__FILE__).'/includes/MapAdminEdits.inc');

        //Create the Google Map key profile array
        if (array_key_exists('MapKeys',$param) and $param['MapKeys'] != "") {
          $temp = explode("|",$param['MapKeys']);
          sort($temp);
          foreach($temp as $tmp){
            $key = explode("`",$tmp);
            $form['ArrayMapKeys'][] = $key;
          }
        } else { //we have no profile, show the "No Profiles" and gather server data to ease fill up
          $form['ArrayMapKeys'][]= array(0,"&laquo; No Profiles &raquo;");
          $form['SRVName'] = GalleryUtilities::getServerVar('HTTP_HOST');
          $form['SRVPort'] = GalleryUtilities::getServerVar('SERVER_PORT');
        }

    	if ($template->hasVariable('SiteAdmin')) {
  	    $SiteAdmin =& $template->getVariableByReference('SiteAdmin');
  	    $SiteAdmin['enctype'] = 'multipart/form-data';
  	} else {
  	    $SiteAdmin['enctype'] = 'multipart/form-data';
  	    $template->setVariable('SiteAdmin', $SiteAdmin);
  	}
        $template->setVariable('controller', 'map.MapSiteAdmin');
  	return array(null,
  		     array('body' => 'modules/map/templates/MapSiteAdmin.tpl'));
      }
}

?>