<?php
/*
 * $Revision: 1.66 $
 *
 * $RCSfile: ShowMap.inc
 *
 * Gallery - a web based photo album viewer and editor
 * Copyright (C) 2000-2005 Bharat Mediratta
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or (at
 * your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
 * @version 0.5.1d
 * @package Map
 * @author Steven N. Severinghaus <sns@severinghaus.org>
 *
 * This is some of the ugliest code I've ever written. Please do not
 * judge me by it. :)
 */

/**
 * This implements the Google map view
 *
 * @package Map
 */

GalleryCoreApi::requireOnce('modules/map/classes/GoogleMapUtilities.class');

class ShowMapController extends GalleryController {
    function handleRequest($form) {
        global $gallery;

	list ($ret, $module) = GalleryCoreApi::loadPlugin('module', 'map');
        if ($ret) {
             return $ret->wrap(__FILE__, __LINE__);
        }

        //When requested to save the settings and popupalte the GPS coordinate
        if (isset($form['cancel']))
        {
            if ($form['plugin'] == 'ItemEdit')
            {
                $results['status'] = '';
                $results['error'] = array ();
                $results['redirect']['view'] = 'core.ItemAdmin';
                $results['redirect']['subView'] = 'core.ItemEdit';
                $results['redirect']['itemId'] = $form['id'];
                $results['redirect']['editPlugin'] = 'mapItemEdit';
            }

            if ($form['plugin'] == 'GroupCoord')
            {
                //return to the page "Edit group"
            $results['status'] = '';
            $results['error'] = array();
            $results['redirect']['view'] = 'core.SiteAdmin';
            $results['redirect']['subView'] = 'map.MapGroupAdmin';
            $results['redirect']['mode'] = 'AddGroup';
            }

            if ($form['plugin'] == 'AdminCenter' or $form['plugin'] == "GVMDefault")
            {
                //return to the page "AdminPanel"
                $results['status'] = '';
                $results['error'] = array ();
                $results['redirect']['view'] = 'core.SiteAdmin';
                $results['redirect']['subView'] = 'map.MapSiteAdmin';
            }

            if ($form['plugin'] == 'Filters')
            {
                //return to the page "Legend Admin Panel"
                $results['status'] = '';
                $results['error'] = array ();
                $results['redirect']['view'] = 'core.SiteAdmin';
                $results['redirect']['subView'] = 'map.MapFilterAdmin';
                $results['redirect']['mode'] = 'AddFilter';
            }
        }
        if (isset($form['save']))
        {
            if ($form['plugin'] == 'ItemEdit' or $form['plugin']=='GroupCoord')
            {
                $groupid = GalleryUtilities::getRequestVariables('groupid');
                if (!empty($groupid)) $id = $groupid;
                else $id = $form['id'];
                $coordinate = $form['coord'];
                $zoom = $form['zoom'];

                $ret = GalleryCoreApi::removeMapEntry('mapMap',
                    array('itemId' => $id, 'field' => 'GPS'));
                if ($ret) {
                     return $ret->wrap(__FILE__, __LINE__);
                }
                //Actually update the database with the coordinated passed on to the ItemID
                $ret = GalleryCoreApi::addMapEntry('mapMap',
                    array('itemId' => $id, 'field' => 'GPS', 'value' => $coordinate, 'setId' => 0, 'setType' => 1));
                if ($ret) {
                     return $ret->wrap(__FILE__, __LINE__);
                }
                $ret = GalleryCoreApi::removeMapEntry('mapMap',
                    array('itemId' => $id, 'field' => 'ZoomLevel'));
                if ($ret) {
                     return $ret->wrap(__FILE__, __LINE__);
                }
                //Actually update the database with the zoomlevel passed on to the ItemID
                $ret = GalleryCoreApi::addMapEntry('mapMap',
                array('itemId' => $id, 'field' => 'ZoomLevel', 'value' => $zoom, 'setId' => 0, 'setType' => 3));
                if ($ret) {
                     return $ret->wrap(__FILE__, __LINE__);
                }

                if ($form['plugin']=='GroupCoord'){
                //Get the coordinates and such in the map database
                $query='
                    SELECT [GallerymapMap::field],
                        [GallerymapMap::value]
                    FROM [GallerymapMap]
                    WHERE [GallerymapMap::itemId] = \''.$id.'\'
                ';
                list($ret, $result) = $gallery->search($query, array(), array());

                $params = "";
                while($param=$result->nextResult()) {
                  if ($params != "") $params = $params."|".$param[0].":".$param[1];
                  else $params = $param[0].":".$param[1];
                }
    
                GalleryCoreApi::setPluginParameter('module', 'map', "EditGroupParam",$params);
                }

                $results['status'] = '';
                $results['error'] = array ();

                if ($form['plugin']=='ItemEdit'){     //return to the page "ItemEdit"
                  $results['redirect']['view'] = 'core.ItemAdmin';
                  $results['redirect']['subView'] = 'core.ItemEdit';
                  $results['redirect']['itemId'] = $id;
                  $results['redirect']['editPlugin'] = 'mapItemEdit';
                } else {   //return to the page "Edit Group"
                  $results['redirect']['view'] = 'core.SiteAdmin';
                  $results['redirect']['subView'] = 'map.MapGroupAdmin';
                  $results['redirect']['mode'] = 'AddGroup';
                }
            }
            
            if ($form['plugin'] == 'AdminCenter')
            {
                
                GalleryCoreApi::setPluginParameter('module', 'map', 'centerLongLat', $form['coord']);
                GalleryCoreApi::setPluginParameter('module', 'map', 'zoomLevel', $form['zoom']);

                //return to the page "AdminPanel"
                $results['status'] = '';
                $results['error'] = array ();
                $results['redirect']['view'] = 'core.SiteAdmin';
                $results['redirect']['subView'] = 'map.MapSiteAdmin';
            }

            if ($form['plugin'] == 'GVMDefault')
            {

                GalleryCoreApi::setPluginParameter('module', 'map', 'GVMCenter', $form['coord']);
                GalleryCoreApi::setPluginParameter('module', 'map', 'GVMZoom', $form['zoom']);

                //return to the page "AdminPanel"
                $results['status'] = '';
                $results['error'] = array ();
                $results['redirect']['view'] = 'core.SiteAdmin';
                $results['redirect']['subView'] = 'map.MapSiteAdmin';
            }

            if ($form['plugin'] == 'Filters')
            {

                $oldeditfilter = GalleryCoreApi::getPluginParameter('module', 'map', 'EditFilter');
                if (!empty($oldeditfilter[1])) {
                  $oldfilter = explode ("`",$oldeditfilter[1]);
                  $oldfilter[2] = $form['zoom'];
                  $oldfilter[3] = $form['coord'];
  
                  $neweditfilter = implode("`",$oldfilter);
                } else {
                  $oldfilters = GalleryCoreApi::getPluginParameter('module', 'map', 'Filters');
                  if (!empty($oldfilters[1])) {
                    $currentfilters = explode("|",$oldfilters[1]);
                    foreach ($currentfilters as $filterinfos) {
                      $infos = explode("`",$filterinfos);
                      $ids[] = $infos[0];
                    }
                    $newid = max($ids)+1;
                    $neweditfilter = $newid."``".$form['zoom']."`".$form['coord'];
                  } else {
                    $neweditfilter = "1``".$form['zoom']."`".$form['coord'];
                  }
                }

                GalleryCoreApi::setPluginParameter('module', 'map', 'EditFilter', $neweditfilter);

                //return to the page "Legend Admin Panel"
                $results['status'] = '';
                $results['error'] = array ();
                $results['redirect']['view'] = 'core.SiteAdmin';
                $results['redirect']['subView'] = 'map.MapFilterAdmin';
                $results['redirect']['mode'] = 'AddFilter';
            }

        }

        return array (null, $results);
    }
}

class ShowMapView extends GalleryView {

    function willshow($itemid, $allids){
      $result = false;
      foreach ($allids as $id=>$value){
        if ($id == $itemid) $result = true;
      }
      return $result;
    }
     /**
     * @see GalleryView::loadTemplate
     */
    function loadTemplate(&$template, &$form) {
        global $gallery;

	list ($ret, $module) = GalleryCoreApi::loadPlugin('module', 'map');
	if ($ret) {
	    return array($ret->wrap(__FILE__, __LINE__), null, null);
	}

        // Gets the real path to the gallery for all file operations to work correctly
        $absolutegallerydir = substr(dirname(__FILE__),0,-11);

        // Include header that links to the Google Maps script

        $template->head('modules/map/templates/MapHeader.tpl');

        list($ret, $param) = GalleryCoreApi::fetchAllPluginParameters('module', 'map');
        if ($ret) {
            return array($ret->wrap(__FILE__, __LINE__), null);
        }

        //creates the array that will be later passed on to ShowMap.inc
        $map=array();
        foreach ($param as $key=>$value){
          $map[$key] = $param[$key];
        }

        if (array_key_exists('ThumbBarPos', $param)) $map['ThumbBarPos'] = $param['ThumbBarPos'];
        if (array_key_exists('ThumbHeight', $param)) $map['ThumbHeight'] = $param['ThumbHeight'];

        $map['useMarkerSet']="none";
        $map['useAlbumMarkerSet']="none";
        $map['useGroupMarkerSet']="none";
        if ((array_key_exists('useMarkerSet',$param)) and (is_dir($absolutegallerydir.'modules/map/images/markers/'.$param['useMarkerSet']))) $map['useMarkerSet']=$param['useMarkerSet'];
        if ((array_key_exists('useGroupMarkerSet',$param) and (is_dir($absolutegallerydir.'modules/map/images/markers/'.$param['useGroupMarkerSet'])))) $map['useGroupMarkerSet']=$param['useGroupMarkerSet'];
        else $map['useGroupMarkerSet'] = $param['useMarkerSet'];
        if ((array_key_exists('useAlbumMarkerSet',$param) and (is_dir($absolutegallerydir.'modules/map/images/markers/'.$param['useAlbumMarkerSet'])))) $map['useAlbumMarkerSet']=$param['useAlbumMarkerSet'];
        else $map['useAlbumMarkerSet']=$map['useMarkerSet'];

        //get the key profiles and select the correct one
        $servername = GalleryUtilities::getServerVar('HTTP_HOST');
        $serverport = GalleryUtilities::getServerVar('SERVER_PORT');

        if (array_key_exists('MapKeys',$param) and $param['MapKeys'] != ""){
          $allkeysets = explode("|",$param['MapKeys']);
          foreach ($allkeysets as $keyset){
            $temp = explode("`",$keyset);
            if (($temp[2] == $servername) and ($temp[3] == $serverport)) $map['googleMapKey'] = $temp[4];
          }
        } else $map['googleMapKey']="";
        $map['WidthFormat'] = ($param['MapWidthFormat'] == "2") ? "%":"px";
        $map['HeightFormat'] = ($param['MapHeightFormat'] == "2") ? "%":"px";
        $map['mapWidth']=$param['mapWidth'];
        $map['mapHeight']=$param['mapHeight'];

        $map['mode'] = GalleryUtilities::getRequestVariables('Mode');
        if (empty($map['mode'])) $map['mode']= "Normal";

//"Normal" Mode to display the map

        $storage=&$gallery->getStorage();
        $gurl=&$gallery->getUrlGenerator();

        //Gets the "URL" path to the gallery for certain operation (like displaying images)
        $urlComponents = parse_url($gurl->getCurrentUrlDir(true));
        $base = $urlComponents['path'];

        //fix for multisite installs
        $baseURL = $gallery->getConfig('galleryBaseUrl');
        if (!empty($baseURL)) $base = $baseURL;

        $map['gallerybase'] = $base;

        unset($map['zoomLevel']);

        if ($map['mode'] == "Normal"){
        // Select items that have GPS coordinates filled out
        $query='
            SELECT [GallerymapMap::itemId],
                [GallerymapMap::value]
            FROM [GallerymapMap]
            WHERE [GallerymapMap::field] = \'GPS\'
        ';
        list($ret, $results) = $gallery->search($query, array(), array());

        //If there is more than 0 Item :-) continue on ...
        if (!$ret and $results->resultCount() > 0)
        {
          $map['nogpscoords']=false;

        // Builds a hash for each mappable entity from its ID to a hash of
        // properties. Not strictly necessary, since it just gets flattened
        // out later, but it could be useful at some point.
        $ids=array();
        $pointHash=array();
        $LevelFilterRoot = isset($param['LevelFilterRoot']) ? $param['LevelFilterRoot']:0;
        $LevelFilterAll = isset($param['LevelFilterAll']) ? $param['LevelFilterRoot']:0;
        $albumfilter = GalleryUtilities::getRequestVariables('album');

        $parentsequences = array();
        list ($ret,$TheRoot) = GalleryCoreApi::getPluginParameter('module','core','id.rootAlbum');  //Grab the ID of the root album

        while($result=$results->nextResult()) {
            $id=$result[0];
            if ($id != $TheRoot and substr($id,0,1) !="G" ) { //retrieve the "parent" sequence for each item (except groups and root album)
              list($ret,$parentsequences[$id]) = GalleryCoreApi::fetchParentSequence($id);
              list($ret, $albuminfos)=$storage->loadEntities($parentsequences[$id]);

              list($ret, $RootAlbumName)=GalleryCoreApi::loadEntitiesById($TheRoot);
                if($LevelFilterRoot == 1 and $albumfilter==$RootAlbumName->getTitle()) {
                        $fromLevel = count($parentsequences[$id])-1;
                }
                elseif($LevelFilterAll > 0) {
                        $fromLevel = (count($parentsequences[$id])-$LevelFilterAll >= 0)?count($parentsequences[$id])-$LevelFilterAll:0;
                }
                else {
                        $fromLevel = 0;
                }
              for ($i=$fromLevel; $i < count($parentsequences[$id]); $i++)
              {
                $parentsequences[$id][$i] = $albuminfos[$i]->getTitle();
              }
	      if ($fromLevel > 0) {
		for ($i=0; $i < $fromLevel; $i++) {
			array_shift($parentsequences[$id]);
		}
	      }

              // get item and parent id
              list ($ret, $item) = GalleryCoreApi::loadEntitiesById($id);
              if ($ret) {
                    return $ret->wrap(__FILE__, __LINE__);
              }
              $parentId = $item->getParentId();
            }

            // Query to retun the "color" select on the item currently being processed by 'Query'

            $query2='
            SELECT [GallerymapMap::itemId],[GallerymapMap::value]
            FROM [GallerymapMap]
            WHERE [GallerymapMap::field] = \'Colors\' AND [GallerymapMap::itemId] = \''.$id.'\'
            ';

            list($ret, $results2) = $gallery->search($query2, array(), array());
            $myresults=$results2->nextResult();
            if ($myresults != null)
            {
                $colorresult = $myresults[1];
            }
            else
            {
                $colorresult = "default";

                // get color from parent, if option selected
                if ((array_key_exists('useParentColor',$param)) and $param['useParentColor']==1)
                {
                    // get color for parent
                    $query2b='
                    SELECT [GallerymapMap::itemId],[GallerymapMap::value]
                    FROM [GallerymapMap]
                    WHERE [GallerymapMap::field] = \'Colors\' AND [GallerymapMap::itemId] = \''.$parentId.'\'
                    ';
                    list($ret, $results2b) = $gallery->search($query2b, array(), array());
                    $myresults2b=$results2b->nextResult();
                    if ($myresults2b != null)
                    {
                        $colorresult = $myresults2b[1];
                    }
                }
            }

            //Query to return the ZoomLevel of the item currently bein processes
            $query3='
            SELECT [GallerymapMap::itemId],[GallerymapMap::value]
            FROM [GallerymapMap]
            WHERE [GallerymapMap::field] = \'ZoomLevel\' AND [GallerymapMap::itemId] = \''.$id.'\'
            ';

            list($ret, $results3) = $gallery->search($query3, array(), array());
            $myresults=$results3->nextResult();
            if ($myresults != null)
                  {$zoomresult = $myresults[1];}
            else
                  {$zoomresult = $param['zoomInLevel'];}

            // Save all those nice parameters into a pointhash array for later use :)
            $ids[]=$id;
            $pointHash[$id]=array();
            $pointHash[$id]['id']=$id;
            $pointHash[$id]['gps']=$result[1];
            $pointHash[$id]['color']=$colorresult;
            $pointHash[$id]['zoomlevel']=$zoomresult;
            if (substr($id,0,1)!="G"){
              $pointHash[$id]['itemLink']=$gurl->generateUrl(
                array('view'=>'core.ShowItem','itemId'=>$id),false);
              $pointHash[$id]['parentId']=$parentId;
              $pointHash[$id]['hasChild']=false;
            }
            else
            {
              $pointHash[$id]['itemLink']=$gurl->generateUrl(
                array('view'=>'map.ShowMap','Group'=>$id),false);
              $pointHash[$id]['type']='GoogleMapGroup';
              $groupid = substr($id,1);
              list ($ret, $tmpparam) = GalleryCoreApi::getPluginParameter('module','map','MapGroups');
              $groups = explode ("|",$tmpparam);
              foreach ($groups as $group){
                $groupinfo = explode ("`",$group);
                if ($groupinfo[0] == $groupid) {
                  $thumbpic = $absolutegallerydir.'modules/map/images/groups/'.$groupinfo[4];
                  $Tsizes = @getimagesize ($thumbpic);
                  $pointHash[$id]['title'] = $groupinfo[1];
                  $pointHash[$id]['summary'] = $groupinfo[2];
                  $pointHash[$id]['description'] = $groupinfo[3];
                  $pointHash[$id]['created'] = $groupinfo[5];
                  $pointHash[$id]['thumbWidth'] = $Tsizes[0];
                  $pointHash[$id]['thumbHeight'] = $Tsizes[1];
                  $pointHash[$id]['thumbbarWidth'] = $Tsizes[0]*$map['ThumbHeight']/$Tsizes[1];
                  $pointHash[$id]['thumbbarHeight'] = $Tsizes[1]*$map['ThumbHeight']/$Tsizes[0];
                  $pointHash[$id]['thumbLink'] = GalleryUtilities::convertPathToUrl($thumbpic);
                  $pointHash[$id]['regroupShowHigh'] = 0;
                  $pointHash[$id]['regroupShowLow'] = 19;
                  $pointHash[$id]['parentDist'] = -1;
                  $pointHash[$id]['hasHiddenChild'] = false;
                  $pointHash[$id]['group'] = -1;
                  $pointHash[$id]['display'] = true;
                }
              }
            }
            $posxy = explode(",", $result[1]);
            if (count($posxy) == 2) {
                $pointHash[$id]['posx']=(float)$posxy[0];
                $pointHash[$id]['posy']=(float)$posxy[1];
            }
            else {
                $pointHash[$id]['posx']="none";
                $pointHash[$id]['posy']="none";
            }
        }


        $isgroup = GalleryUtilities::getRequestVariables('Group');
        if (!empty($isgroup)) { //We're dealing with a group display, removing all item not in the group
          //Get the group
          if (array_key_exists('MapGroups',$param) and $param['MapGroups'] != ""){ //we have some groups, let's check
            $allgroups = explode("|",$param['MapGroups']);
            $theonegroup = array();
            foreach ($allgroups as $agroup){
              $tmp = explode ("`",$agroup);
              if ("G".$tmp[0] == $isgroup) $theonegroup = $tmp;
            }
            if (!empty($theonegroup)) {
             $map['Filter'] = "Group: ".$theonegroup[1]."  <a href=".$gurl->generateUrl(
                array('view'=>'map.ShowMap','Group' => ''),false).">Show All</a>";
             $NumberOfIds = count($ids);
             for ($i=0; $i <$NumberOfIds; $i++) {
               $inGroup = false;
               for ($j=6;$j<count($theonegroup);$j++){
                 if ($theonegroup[$j] == $ids[$i]) $inGroup=true;
               }
               if (!$inGroup){
                 unset($pointHash[$ids[$i]]);
                 unset($ids[$i]);
               }
             }
            } else { //No group found corresponding, joke ?
              $map['GroupHackingError']=1;
            }
          } else { //No groups at all ...
            $map['GroupHackingError']=1;
          }
          $ids=array_values($ids);
        }


        $tmp=array();
        //create an ID array without the groups in it
        foreach ($ids as $id) if (substr($id,0,1)!="G") $tmp[] = $id;
        $ids = $tmp;

        // Trim the list down to the items that the user is allowed to see
        list($ret, $perms)=GalleryCoreApi::fetchPermissionsForItems($ids,$gallery->getActiveUserId());
        $NumberOfIds = count($ids);
        for($i=0;$i<$NumberOfIds;$i++)
        {
            if(!array_key_exists($ids[$i], $perms) || !array_key_exists("core.view", $perms[$ids[$i]]))
            {
                unset($pointHash[$ids[$i]]);       //remove the item from our list
                unset($parentsequences[$ids[$i]]); //Remove the item from the parentsequences (so that empty album don't show up)
                unset($ids[$i]);
            }
        }
        $ids=array_values($ids);

        if (count($ids) > 0)
        {
        $map['noitemperms']=false;

        //Get the list of album with GPS Item in them
        $map['listalbums'] = $parentsequences;
        $temp = array();
        foreach($map['listalbums'] as $tmp) $temp[] = implode("`",$tmp);
        $listofalbums = implode ("`",array_unique($temp));
        $temp = explode ("`",$listofalbums);
        $listofalbums = implode ("`",array_unique($temp));
        GalleryCoreApi::setPluginParameter('module','map','albumlist',$listofalbums);

        //Trim the list if the "Album" filter is ON
        //$albumfilter = GalleryUtilities::getRequestVariables('album');

        $map['noiteminalbum']=false;
        if (!empty($albumfilter)){
          $map['Filter'] = "Album: ".$albumfilter;
          $NumberOfIds = count($ids);
          for ($i=0; $i <$NumberOfIds; $i++) {
            $pos = $ids[$i];
            $InAlbum = false;
            if ($pos != $TheRoot){
              for ($j=0; $j<count($parentsequences[$pos]); $j++){
                if (strtolower($parentsequences[$pos][$j]) == strtolower($albumfilter))
                {
                  $InAlbum = true;
                  break;
                }
              }
            }  
            if (!$InAlbum) {
              unset ($pointHash[$pos]);
              unset ($ids[$i]);
            }
          }
        }

        $ids=array_values($ids);

        if (count($ids)>0){
        // Retrieve data for each entity
        list($ret, $entities)=$storage->loadEntities($ids);
        list($ret, $thumbs)=GalleryCoreApi::fetchThumbnailsByItemIds($ids);

        // Fetch the default date format for the gallery
        list($ret, $coreParams)=GalleryCoreApi::fetchAllPluginParameters('module', 'core');
        $dateFormat=$coreParams['format.date'];

        // Fill out additional properties for each entity, taking care to
        // format them so that they don't break the Javascript that they
        // end up embedded within.
        foreach ($entities as $entity) {
            $theid = $entity->getId();
            $pointHash[$theid]['type']=$entity->getEntityType();
            $pointHash[$theid]['title']=
                preg_replace(array('/\n/','/\r/'), array('',''), $entity->getTitle());
            $pointHash[$theid]['summary']=
                preg_replace(array('/\n/','/\r/'), array('',''), $entity->getSummary());
            $pointHash[$theid]['description']=
                preg_replace(array('/\n/','/\r/'), array('',''), $entity->getDescription());
            if (array_key_exists($theid,$thumbs)){
              $pointThumb = $thumbs[$theid];
              $pointHash[$theid]['thumbLink']=$gurl->generateUrl(
                  array('view'=>'core.DownloadItem',
                  'itemId'=>$pointThumb->getId(),
                  'serialNumber'=>$pointThumb->getSerialNumber()));
              $pointHash[$theid]['thumbWidth'] = $thumbs[$theid]->getWidth();
              $pointHash[$theid]['thumbHeight'] = $thumbs[$theid]->getHeight();
            }else{
              $pointHash[$theid]['thumbLink']="";
              $pointHash[$theid]['thumbWidth'] = "100";
              $pointHash[$theid]['thumbHeight'] = "100";
            }
            $pointHash[$theid]['created']=strftime($dateFormat, $entity->getCreationTimestamp());
            $pointHash[$theid]['thumbbarWidth'] = $map['ThumbHeight']*$pointHash[$theid]['thumbWidth']/$pointHash[$theid]['thumbHeight'];
            $pointHash[$theid]['thumbbarHeight'] = $map['ThumbHeight']*$pointHash[$theid]['thumbHeight']/$pointHash[$theid]['thumbWidth'];


            // prepare for regrouping
            $pointHash[$theid]['regroupShowHigh'] = 0;
            $pointHash[$theid]['regroupShowLow'] = 19;
            $parentId = $pointHash[$theid]['parentId'];

            if (array_key_exists($pointHash[$theid]['parentId'], $pointHash) and (array_key_exists('regroupAlbums', $param) and array_key_exists('regroupDist', $param) and $param['regroupAlbums']==1)) {
                $point = $pointHash[$theid];
                $parentDist = GoogleMapUtilities::cylindricalProjectionDiff($point['posx'], $point['posy'], $pointHash[$parentId]['posx'], $pointHash[$parentId]['posy']);
                $pointHash[$theid]['parentDist'] = $parentDist;
                $pointHash[$parentId]['hasChild'] = true;
            }
            else {
                $pointHash[$theid]['parentDist'] = -1;
                $pointHash[$theid]['hasHiddenChild'] = false;
            }
            $pointHash[$theid]['group'] = -1;
            $pointHash[$theid]['display'] = true;
        }

        // Flatten out the pointHash to prepare it for use in the template
        $mapPoints=array();
        foreach ($pointHash as $id => $point) {
            $mapPoints[$id]=$point;
        }
        //ITEM REGROUP GOES HERE

        } else $map['noiteminalbum'] = true; //No item in the selected album
        } else $map['nogpscoords'] = true;  //There is no marker because no item with GPS coordinate have correct permission
        } else $map['noitemperms'] = true;   //There is no marker because no item have GPS coordinate


        // Set various parameters needed by ShowMap.tpl, accessible as {$map.mapWidth}, etc.
        if (isset($mapPoints)) $map['mapPoints']=$mapPoints;
        else $map['mapPoints'] = array();

        //get the key profiles and select the correct one
        $servername = GalleryUtilities::getServerVar('HTTP_HOST');
        $serverport = GalleryUtilities::getServerVar('SERVER_PORT');

        if (array_key_exists('MapKeys',$param) and $param['MapKeys'] != ""){
          $allkeysets = explode("|",$param['MapKeys']);
          foreach ($allkeysets as $keyset){
            $temp = explode("`",$keyset);
            if (($temp[2] == $servername) and ($temp[3] == $serverport)) $map['googleMapKey'] = $temp[4];
          }
        } else $map['googleMapKey']="";
        $map['WidthFormat'] = ($param['MapWidthFormat'] == "2") ? "%":"px";
        $map['HeightFormat'] = ($param['MapHeightFormat'] == "2") ? "%":"px";
        $map['mapWidth']=$param['mapWidth'];
        $map['mapHeight']=$param['mapHeight'];

        $map['mapType']=$param['mapType'];

        $filter = GalleryUtilities::getRequestVariables('filter');
        if (!empty($filter)) {
            if (!array_key_exists('Filters',$param) and substr($filter,0,5)!="Route") $map['filterhackingerror']=1;
            else {
              $currentfilters = $param['Filters'];
              if ($currentfilters != ""){
                $filterarray = explode("|",$currentfilters);
                foreach ($filterarray as $filterinfos) {
                  $infos = explode("`",$filterinfos);
                  if ($infos[1] == $filter)
                  {
                    $map['centerLongLat'] = $infos[3];
                    $map['zoomLevel'] = $infos[2];
                    $map['Filter'] = $infos[1];
                    break;
                  }
                }
              }
              if (substr($filter,0,5) == "Route")  //filtering on a route, create the values on the fly
              {
                list ($ret, $routes) = GalleryCoreApi::getPluginParameter('module','map','Routes');
                if ($ret) {
                     return $ret->wrap(__FILE__, __LINE__);
                }

    	        $routefilters=array();
                if (!empty($routes)) { //we have some routes
    	           $routearray = explode ("|",$routes);
    	           foreach ($routearray as $route) {//go through the route to select the ONE
                     $routeinfos = explode ("`",$route);
                     if ($routeinfos[6] == "Yes" and $routeinfos[1] == substr($filter,7,strlen($filter)-7)) {  //found it !
                      //make an array with the coordinates
                      $routecoords=array();
                      for ($i=7; $i < count($routeinfos); $i++) {
                       $query='
                       SELECT [GallerymapMap::itemId],[GallerymapMap::value]
                       FROM [GallerymapMap]
                       WHERE [GallerymapMap::field] = \'GPS\' AND [GallerymapMap::itemId] = \''.$routeinfos[$i].'\'
                       ';
                       list($ret,$qresults) = $gallery->search ($query);
                       $qresult = $qresults->nextResult();

                       $routecoords[]=$qresult[1];
                      }

                      //find the best values for center and zoom
                      GoogleMapUtilities::GetZoomandCenter($routecoords,$routezoom,$routecenter,$map['mapWidth'],$map['mapHeight'],$mercmil,$merclon);
                      $map['mercmil']=str_replace(",",".",$mercmil);
                      $map['merclon']=str_replace(",",".",$merclon);


                      $map['centerLongLat'] = $routecenter;
                      $map['zoomLevel'] = $routezoom;
                      $map['Filter'] = $filter;
                     }
                   }
                } else { // we don't have any routes ... must be an error
                  $map['filterhackingerror']=1;
                }
              }
              if (!array_key_exists('centerLongLat',$map)) $map['filterhackingerror']=1;
            }
        } else {
          if ($map['mode'] == "Normal"){
            $map['AutoCenterZoom']=$param['AutoCenterZoom'];
            $map['centerLongLat']=$param['centerLongLat'];
            $map['zoomLevel']=$param['zoomLevel'];
          }
        }
        $map['zoomInLevel']= (array_key_exists('zoomInLevel',$param)) ? $param['zoomInLevel']:"0";
        $map['showZoomScale']= (array_key_exists('showZoomScale',$param)) ? $param['showZoomScale']:"0";
        $map['showMapType']=(array_key_exists('showMapType',$param)) ? $param['showMapType']:"0";
        $map['showScale']=(array_key_exists('showScale',$param)) ? $param['showScale']:"0";
        $map['showZoomLinks']=(array_key_exists('showZoomLinks',$param)) ? $param['showZoomLinks']:"0";
        $map['showItemSummaries']=(array_key_exists('showItemSummaries',$param)) ? $param['showItemSummaries']:"0";
        $map['showItemDescriptions']=(array_key_exists('showItemDescriptions',$param)) ? $param['showItemDescriptions']:"0";
        $map['MapControlType']=(array_key_exists('MapControlType',$param)) ? $param['MapControlType']:"Small";
        $map['MapControlPos']=(array_key_exists('MapControlPos',$param)) ? $param['MapControlPos']:"0";
        $map['MapControlPosOffY']=(array_key_exists('MapControlPosOffY',$param)) ? $param['MapControlPosOffY']:"30";
        $map['MapControlPosOffX']=(array_key_exists('MapControlPosOffX',$param)) ? $param['MapControlPosOffX']:"30";
        $map['defaultalbumcolor']= '';
        $map['defaultphotocolor']= '';
        if (array_key_exists('defaultalbumcolor',$param)) $map['defaultalbumcolor']=$param['defaultalbumcolor'];
        if (array_key_exists('defaultphotocolor',$param)) $map['defaultphotocolor']=$param['defaultphotocolor'];

        if (array_key_exists('GxMagnifier',$param))
        {
          $map['GxMagnifier'] = $param['GxMagnifier'];
        }
        else
        {
          $map['GxMagnifier'] = false;
        }
        if ($map['GxMagnifier']){
            $map['GxZoom']=$param['GxZoom'];
            $map['GxZoomNum']=$param['GxZoomNum'];
            $map['GxSize']=$param['GxSize'];
            $map['GxSizeX']=$param['GxSizeX'];
            $map['GxSizeY']=$param['GxSizeY'];
            $map['GxPos']=$param['GxPos'];
            $map['GxAutoPan']=$param['GxAutoPan'];
        }
        if (array_key_exists('GxMagnifier2',$param))
        {
          $map['GxMagnifier2'] = $param['GxMagnifier2'];
        }
        else
        {
          $map['GxMagnifier2'] = false;
        }
        if ($map['GxMagnifier2']){
            $map['Gx2ZoomNum']=$param['Gx2ZoomNum'];
            $map['Gx2SizeX']=$param['Gx2SizeX'];
            $map['Gx2SizeY']=$param['Gx2SizeY'];
            $map['Gx2Pos']=$param['Gx2Pos'];
            $map['Gx2Type']=$param['Gx2Type'];
            $map['Gx2Content']=$param['Gx2Content'];
            $map['Gx2PosOffX']=$param['Gx2PosOffX'];
            $map['Gx2PosOffY']=$param['Gx2PosOffY'];
        }

        if ($map['GxMagnifier'] or $map['GxMagnifier2']) {
            $true = setcookie ("basegx",$base."modules/map/GxMagnifier");
            $template->javascript($base.'modules/map/GxMagnifier/GxMagnifier.2.js');
        }

        if (array_key_exists('DatelineFix',$param))
        {
            $map['DatelineFix'] = $param['DatelineFix'];
        }
        else
        {
            $map['DatelineFix'] = false;
        }

        //preload IMG for IE
  	$Sizes = array();
        $SizesA = array();
        $SizesG = array();
        $rep = $absolutegallerydir.'modules/map/images/markers/'.$map['useMarkerSet'].'/';
        $repA = $absolutegallerydir.'modules/map/images/markers/'.$map['useAlbumMarkerSet'].'/';
        $repG = $absolutegallerydir.'modules/map/images/markers/'.$map['useGroupMarkerSet'].'/';
        $imgrep = $map['gallerybase']."modules/map/images/markers/".$map['useMarkerSet']."/";
        $imgrepA = $map['gallerybase']."modules/map/images/markers/".$map['useAlbumMarkerSet']."/";
        $imgrepG = $map['gallerybase']."modules/map/images/markers/".$map['useGroupMarkerSet']."/";

        //Preload Photo Icons
        if ($map['useMarkerSet'] <> "none")
        {
           $map['preload']='';
           $mydir = dir($rep);

           while (($file = $mydir->read()) !== false)
           {
             if (($file <> "colorlist") and !is_dir($file) and substr($file,-1)!="." and $file != "CVS")
             {
               $map['preload'] = $map['preload']. "<div style='display:none'><img alt='none' src='".$imgrep.$file."' /></div>";
               if (!is_array($Sizes) or !array_key_exists("0",$Sizes)) $Sizes = @getimagesize($rep.$file);
             }
           }

           $mydir->close();
          }

          //Preload Album Icons
          if ($map['useAlbumMarkerSet'] <> "none")
          {
            if (!isset($map['preload'])) $map['preload']='';
           $mydir = dir($repA);

            while (($file = $mydir->read()) !== false)
            {
              if (($file <> "colorlist") and !is_dir($file) and substr($file,-1)!="." and $file != "CVS")
              {
                $map['preload'] = $map['preload']. "<div style='display:none;'><img alt='none' src='".$imgrepA.$file."' style='display:none;'/></div>";
                if (!is_array($SizesA) or !array_key_exists("0",$SizesA)) $SizesA = @getimagesize($repA.$file);
              }
            }
            $mydir->close();
           }

          //Preload Group Icons
          if ($map['useGroupMarkerSet'] <> "none")
          {
            if (!isset($map['preload'])) $map['preload']='';
           $mydir = dir($repG);

            while (($file = $mydir->read()) !== false)
            {
              if (($file <> "colorlist") and !is_dir($file) and substr($file,-1)!="." and $file != "CVS")
              {
                $map['preload'] = $map['preload']. "<div style='display:none;'><img alt='none' src='".$imgrepG.$file."' style='display:none;'/></div>";
                if (!is_array($SizesG) or !array_key_exists("0",$SizesG)) $SizesG = @getimagesize($repG.$file);
              }
            }
            $mydir->close();
           }

        $map['MarkerSizeX']=$Sizes[0];
        $map['MarkerSizeY']=$Sizes[1];
        $map['AlbumMarkerSizeX']=$SizesA[0];
        $map['AlbumMarkerSizeY']=$SizesA[1];
        $map['GroupMarkerSizeX']=$SizesG[0];
        $map['GroupMarkerSizeY']=$SizesG[1];

        if ((array_key_exists('Routes',$param)) and ($param['Routes']!=""))
        {
          $allrouteparam = array();
          $routes = explode("|",$param['Routes']);
          foreach ($routes as $route)
          {
            $tmppoint = array();
            $tmpparam = array();
            $rawitem = array();
            $routeinfo = explode("`",$route);
            for ($i=0; $i<7; $i++)
            {
              $tmpparam[]= $routeinfo[$i];
            }
            
            GalleryUtilities::guaranteeDirExists($absolutegallerydir."modules/map/images/routes/".$routeinfo[1]);
            
            $nb = 0;

            for ($i=7; $i < count($routeinfo); $i++)
            {
              if (ShowMapView::willshow($routeinfo[$i],$map['mapPoints'])){
                $rawitem[] = $routeinfo[$i];
                $nb++;
                //Get info on the item to create the "route numerical marker"
                list($ret, $item)=GalleryCoreApi::loadEntitiesById($routeinfo[$i]);
                $type = $item->getEntityType();
                $imagename = ($type == "GalleryAlbumItem")? $map['useAlbumMarkerSet']: (($type=="GalleryPhotoItem")? $map['useMarkerSet']:$map['useGroupMarkerSet']);
                $defaultcolor = ($type == "GalleryAlbumItem")? $map['defaultalbumcolor']: (($type=="GalleryPhotoItem")? $map['defaultphotocolor']:$map['defaultgroupcolor']);
                $query='
                  SELECT [GallerymapMap::itemId],[GallerymapMap::value]
                  FROM [GallerymapMap]
                  WHERE [GallerymapMap::field] = \'Colors\' AND [GallerymapMap::itemId] = \''.$routeinfo[$i].'\'
                  ';
                 list($ret,$cresults) = $gallery->search ($query);
                 $cresult = $cresults->nextResult();
                 $color = ($cresult != null)? $cresult[1]:$defaultcolor;
                 if (array_key_exists($routeinfo[$i],$map['mapPoints'])) $map['mapPoints'][$routeinfo[$i]]['color'] = $color;
  
                 $sourceimage = $absolutegallerydir.'modules/map/images/markers/'.$imagename.'/marker_'.strtoupper($color).'.png';
                 $destination = $absolutegallerydir.'modules/map/images/routes/'.$routeinfo[1].'/'.$nb.'-marker_'.strtoupper($color).'.png';

                 $picsize = @getimagesize($sourceimage);

                 $xpos = $picsize[0]/2 - 3;
                 $ypos = $picsize[1]/2 + 2;

                 $command = 'convert "'.$sourceimage.'" -draw "text '.$xpos.','.$ypos.' \''.$nb.'\'" "'.$destination.'"';
                 $returnstuff = system($command);
  
                //for each item, grab the coordinates and store them in an array.
                $query='
                  SELECT [GallerymapMap::itemId],[GallerymapMap::value]
                  FROM [GallerymapMap]
                  WHERE [GallerymapMap::field] = \'GPS\' AND [GallerymapMap::itemId] = \''.$routeinfo[$i].'\'
                  ';
                 list($ret,$qresults) = $gallery->search ($query);
                 $qresult = $qresults->nextResult();
                 $coord = explode(",",$qresult[1]);
                 $tmppoint[] = $coord;
              }
            }
            $map['routeitem'][$routeinfo[1]] = $rawitem;
            $tmpparam[]=$tmppoint;
            $allrouteparam[]=$tmpparam;
          }
        $map['Routes']=$allrouteparam;
        }
        $map['MapWindowType'] = (array_key_exists('MapWindowType',$param)) ? $param['MapWindowType']:"default";

        if (array_key_exists('AlbumLegend', $param))       $map['AlbumLegend'] = $param['AlbumLegend'];
        if (array_key_exists('PhotoLegend', $param))       $map['PhotoLegend'] = $param['PhotoLegend'];
        if (array_key_exists('ExpandAlbumLegend', $param)) $map['ExpandAlbumLegend'] = $param['ExpandAlbumLegend'];
        if (array_key_exists('ExpandPhotoLegend', $param)) $map['ExpandPhotoLegend'] = $param['ExpandPhotoLegend'];
        if(!array_key_exists('AlbumLegends', $param))      $map['AlbumLegends']="";
        else $map['AlbumLegends'] = $param['AlbumLegends'];
        if(!array_key_exists('LegendPos', $param))        $map['LegendPos']=0;  //Right by dedfault
        else $map['LegendPos'] = $param['LegendPos'];
        if(!array_key_exists('PhotoLegends', $param))      $map['PhotoLegends']="";
        else $map['PhotoLegends'] = $param['PhotoLegends'];

        if ($map['PhotoLegends'] <> "") {
          $photolegends = explode("|",$map['PhotoLegends']);
          $map['PhotoLegends'] = $photolegends;
        }
        if ($map['AlbumLegends'] <> "") {
          $albumlegends = explode("|",$map['AlbumLegends']);
          $map['AlbumLegends'] = $albumlegends;
        }

        $map['allmarkers'] = GoogleMapUtilities::AllMarkers();

        //Test for the existance of a sidebar on the google map view
        $map['sidebar']=1;

        // Grab the Default theme value (used for the google map)
        list ($ret, $themeId) = GalleryCoreApi::getPluginParameter('module', 'core', 'default.theme');
        if ($ret) {
	    return array($ret->wrap(__FILE__, __LINE__), null);
	}
	//Grab the Theme Default settings
        list ($ret, $deftheme) = GalleryCoreApi::loadPlugin('theme', $themeId);
        if ($ret) {
	    return array($ret->wrap(__FILE__, __LINE__), null);
        }
        $settings = $deftheme->getSettings(null);
        if (array_key_exists('2', $settings)){
          $settings = $settings[2];
  
          foreach ($settings as $key=>$value) {
            if ($key == "sidebarBlocks") {
              list ($success, $sidebarvalue) = $deftheme->unpackSetting('block-list', $value);
              if ($sidebarvalue == '') $map['sidebar']=0;
            }
          }
        } else $map['sidebar'] = 0;

        if (!array_key_exists('ShowFilters',$param)) $param['ShowFilters']="0";
        $map['ShowFilters']=$param['ShowFilters'];

        include ($absolutegallerydir."modules/map/templates/infowindow/".$map['MapWindowType'].".inc");

        //Features:

        }

//If the "Pick" Mode is required ...
        if ($map['mode'] == "Pick"){
        //Get the itemId to be able later to populate the coordinated picked out.
        $form['id'] = GalleryUtilities::getRequestVariables('itemId');
        $map['plugin'] = GalleryUtilities::getRequestVariables('plugin');
        $form['formName'] = 'ShowMap';

        //Get the thumb to display
        list($ret, $thumb)=GalleryCoreApi::fetchThumbnailsByItemIds(array($form['id']));

        if (array_key_exists($form['id'],$thumb)){
              $form['itemthumb']=$gurl->generateUrl(
                  array('view'=>'core.DownloadItem',
                  'itemId'=>$thumb[$form['id']]->getId(),
                  'serialNumber'=>$thumb[$form['id']]->getSerialNumber()));
        }

        // get data for item edit
        if ($map['plugin'] == 'ItemEdit' or $map['plugin'] == 'GroupCoord')
        {
            $groupid = GalleryUtilities::getRequestVariables('groupid');
            if (!empty($groupid)) $form['id'] = $groupid;

            // Get coordinates for this item
            $query='
                SELECT [GallerymapMap::field],
                    [GallerymapMap::value]
                FROM [GallerymapMap]
                WHERE [GallerymapMap::itemId] = \''.$form['id'].'\'
            ';
            list($ret, $results) = $gallery->search($query, array(), array());

            if ($results->resultCount()>0) {
                while($result=$results->nextResult()) {
                    if ($result[0] == 'GPS') {
                        $map['coordinates'] = $result[1];
                    }
                    if ($result[0] == 'ZoomLevel') {
                        $map['zoomLevel'] = $result[1];
                    }
                    if ($result[0] == 'Colors') {
                        $map['colors'] = $result[1];
                    }
                }
            }

            if ($map['plugin'] != 'GroupCoord'){
              list ($ret, $item) = $this->_getItem();
              $set = GalleryUtilities::isA($item, 'GalleryAlbumItem') ? 'album'
                  : (GalleryUtilities::isA($item, 'GalleryPhotoItem') ? 'photo' : 'common');
              $map['type'] = $set;
            }
	}

        if ($map['plugin'] == 'AdminCenter' and !$map['AutoCenterZoom']) {
            if (isset($param['centerLongLat']))    $map['centerLongLat'] = $param['centerLongLat'];
            if (isset($param['zoomLevel']))        $map['zoomLevel'] = $param['zoomLevel'];

            $map['colors'] = '';
            $map['type'] = "common";
        }

        if ($map['plugin'] == 'Filters') {

          $map['filter']=true;

          $center = GalleryUtilities::getRequestVariables('center');
          $zoom = GalleryUtilities::getRequestVariables('zoom');
          if (!empty($center)) $map['coordinates'] = $center;
          if (!empty($zoom)) $map['zoomLevel'] = $zoom;
        }

        // make sure parameters are set.
        if (!isset($map['coordinates'])){
          if (isset($map['GVMCenter']) and $map['GVMCenter'] != "") $map['centerLongLat'] = $map['GVMCenter'];
          else $map['centerLongLat'] = "-12,20";
        } else $map['centerLongLat'] = $map['coordinates'];
        if (!isset($map['zoomLevel']) or $map['zoomLevel'] == "")      {
          if (isset($map['GVMZoom']) and $map['GVMZoom'] != "") $map['zoomLevel'] = $map['GVMZoom'];
          else $map['zoomLevel'] = "15";
        }
        if (!isset($map['colors']))         $map['colors'] = "";
        if (!isset($map['type']))           $map['type'] = "common";
        if (!isset($map['mapType']))        $map['mapType'] = "G_MAP_TYPE";

        //Feature set transfert
        if (array_key_exists('LegendFeature',$param)) $map['LegendFeature'] = $param['LegendFeature'];

        $template->setVariable('controller', 'map.ShowMap');

        }

        $map['hasadminrights'] = false;
        $ret = GalleryCoreApi :: assertUserIsSiteAdministrator();
        if (!$ret) {
          $map['hasadminrights'] = true;
        }

        $template->setVariable('map', $map);

        // Render the actual template with the map display
        return array(null,
            array('body' => 'modules/map/templates/ShowMap.tpl'));
    }

}
?>
